// -*- C++ -*-

#include <vector>
#include <iostream>

struct Matrix {
    typedef std::vector< std::vector< bool > > Data;
    Data data;

    void resize( int x ) {
        data.resize( x );
        for ( int i = 0; i < x; ++i )
            data[i].resize( x );
    }

    explicit Matrix( int s ) {
        resize( s );
    }

    Matrix() {}

    Matrix( const Matrix &m ) : data ( m.data ) {
    }

    std::vector< bool > &operator[]( int i ) {
        return data[i];
    }

    int size() const {
        return data.size();
    }

    void print( std::ostream &o ) const {
        for ( int row = 0; row < size(); ++ row ) {
            for ( int col = 0; col < size(); ++ col )
                o << data[row][col] << " ";
            o << std::endl;
        }
    }

    void read( std::istream &i ) {
        int s;
        bool x;

        i >> s;
        resize( s );
        for ( int row = 0; row < size(); ++ row ) {
            for ( int col = 0; col < size(); ++ col ) {
                i >> x;
                data[row][col] = x;
            }
        }
    }

    void closure();
};
