#include <pthread.h>
#include <time.h>
#include <sys/time.h>
#include <vector>
#include <iostream>
#include <fstream>
#include "common.h"
#include <stdlib.h>

using namespace std;

timeval timer;

void startTimer() {
    gettimeofday( &timer, NULL );
}

unsigned int stopTimer() {
    timeval tmp;
    gettimeofday( &tmp, NULL );
    tmp.tv_sec -= timer.tv_sec;
    tmp.tv_usec -= timer.tv_usec;
    if ( tmp.tv_usec < 0 ) {
        tmp.tv_usec += 1000000;
        tmp.tv_sec--;
    }
    return tmp.tv_usec / 1000 + tmp.tv_sec * 1000;
}

int main( int argc, char **argv ) {
    Matrix m( 1000 );
    bool isrand = true;

    if ( argc > 1 ) {
        char *endptr;
        int s = strtol( argv[1], &endptr, 10 );
        if ( endptr != argv[1] ) {
            m.resize( s );
            if ( argc > 2 )
                srand( atoi( argv[2] ) );
        } else {
            std::ifstream i( argv[1] );
            m.read( i );
            isrand = false;
        }
    }

    if (isrand) {
        for ( int i = 0; i < m.size(); ++ i ) {
            for ( int j = 0; j < m.size(); ++ j ) {
                m[i][j] = random() % 2;
            }
        }
    }

    if (isrand)
        m.print( std::cout );

    startTimer();
    m.closure();
    unsigned time = stopTimer();

    std::cout << m.size() << std::endl;
    m.print( std::cout );

    std::cerr << "done in " << time << "ms" << std::endl;

    return 0;
}
